// filename ******** Main.C ************** 
// MC9S12DP512 example   
// TCNT increments at a fixed rate
// PP7 is output to LED
//    Jonathan W. Valvano 10/26/2010
#include <hidef.h>      /* common defines and macros */
#include "derivative.h" /* derivative-specific definitions */


//--------------------Timer_Init---------------
// initialize timer module to 1us(Run Mode) TCNT clock
// inputs: none
// outputs: none            
void Timer_Init(void){
  TSCR1 = 0x80;   // Enable TCNT, 8MHz in run modes
  TSCR2 = 0x03;   // divide by 8 TCNT prescale, TCNT at 1usec
  PACTL = 0;      // timer prescale used for TCNT
/* Bottom three bits of TSCR2 (PR2,PR1,PR0) determine TCNT period
    divide  8MHz E clock    
000   1    125ns    
001   2    250ns     
010   4    500ns         
011   8      1us   	 
100  16      2us   	 
101  32      4us  		 
110  64      8us     
111 128     16us      */ 
// Be careful, TSCR1 and TSCR2 maybe set in other rituals
}

//---------------------Timer_mwait---------------------
// wait specified number of msec
// Input: number of msec to wait
// Output: none
// assumes TCNT timer is running at 1us
void Timer_mwait(unsigned short msec){ 
unsigned short startTime;
  for(; msec>0; msec--){
    startTime = TCNT;
    while((TCNT-startTime) <= 1000){} 
  }
}

short counter;
void main(void) {
  EnableInterrupts;
  Timer_Init();
  DDRP |= 0x80;    // PP7 output to LED

  for(;;) {
     counter++;
     Timer_mwait(500);  // 0.5sec wait
     PTP ^= 0x80;  // flashes at 1 Hz
  } 
}
